
  highspeedTGXf - Receiver - Proof-of-Concept by Ian Latter, MidnightCode.org

  Use: ./highspeedTGXf video.mov

  Coded March-June 2015, published July 2015 prior to BsidesLV and DefCon in the USA.

  Following the Ars advice;
    Thus, make sure you always commit your latest changes to GitHub before getting on a plane.
    http://arstechnica.com/security/2015/05/arms-control-treaty-could-land-security-researchers-like-me-in-jail/

  This program successfully downloaded 5.5MB at 12.1Mbps (1240 x 650 x 3bpp x 10fps),
  as "uploaded" by a web browser using HTML5 Canvas.

Requirements
============

    OpenCV3.0
    CMake

Compilation
===========

    mkdir build
    cd build
    cmake ../
    make

Running
=======

    # To run the decoder against the test video, change to the build directory and
    # run it against the supplied videos
    cd ../build
    ./highspeedTGXf ../../DeckLink-720p60-8fps-1bpp.mov

Thanks
======

  With much thanks to David Millan Escriva | Damiles

  The highspeedTGXf proof-of-concept was built out of the clientlessTGXf PoC which
  in turn whas literally constructed from two of Damiles demonstrator programs on
  character recognition and processing;

    Basic OCR
      Tutorial: http://blog.damiles.com/2008/11/basic-ocr-in-opencv/
      Source:   https://github.com/damiles/basicOCR/

    Blob and Contour Detection;
      Tutorial: http://blog.damiles.com/2010/12/segmentation-and-feature-extraction-contours-and-blob-detection/
      Source:   https://github.com/damiles/Segmentation-Tutorial

  In the case of highspeedTGXf, none of this OCR or Contour code was required, but
  it would have been a much heavier learning curve without this starting point.

Notes
=====

  1. Incorrect pixel colour values / Converting video

	The Black Magic Design DeckLink 4K Extreme 12G worked out of the box under
	64bit Linux Mint 17, however I could not find a program that correctly 
	parsed/display the RGB content that had been captured as an uncompressed/
	lossless 10 bit-per-channel AVI file (including OpenCV3.0).  BMD's support 
	were able to demonstrate the the Media Express program was saving and then
	reopening the file correctly (I validated this from the native TGA screen
	grabs which GIMP could work with correctly.  In the end, I found that the
	ffmpeg of the day (2.7.2) could read the R210 RGB48LE encoded AVI closest;
	though it somehow ended up in a reduced colour-depth mode (16-235 per
	channel - some sort of quantisation perhaps?) even though GIMP showed this
	wasn't the case in the source.  This card was used to capture the 3BPP
	video.

	The Black Magic Design DeckLink Mini Recorder also worked out of the box
	under 64bit Linux Mint 17, however it captured HDMI data in YUV and not
	"raw" RGB.  This card was used to capture the 1BPP video.

	Hence for both cards the highspeedTGXf decoder was seeing "inaccurate" 
	color values for the target pixels, and thus uses "lower values" as 
	binary zero and "higher values" as binary one.  Not ideal, but functional.

	The conversion command I used for the files provided in this source bundle
	was as follows;
 
	  ffmpeg -i DeckLink-720p60-8fps-1bpp.avi \
            -an -c:v qtrle -pix_fmt rgb24 DeckLink-720p60-8fps-1bpp.mov

	This converts the R210 RGB48LE Media Express AVI to a QuickTime RGB 
	24 bits-per-pixel "lossless" MOV file.  The resulting MOV file is quite 
	portable.

	Much thanks to Warren Young's 2011 post;
	  http://superuser.com/questions/347433/how-to-create-an-uncompressed-avi-from-a-series-of-1000s-of-png-images-using-ff

  2. Changing the bit-per-pixel decoder type

	To change the decoder to match the bits per pixel of the source encoding
	you will need to change the code and recompile - see line 128 of main.cpp;

	  #define TGXF_BPP 1

	Valid options are 1 or 3.  24bpp has not been tested (see 1, above).

	Yes, this should be a command line option, but its a proof-of-concept ..

  3. Changing the packet resolution

	The packet resolution can be changed via packet_width and packet_height at
	line 970 of main.cpp;

	  unsigned int packet_width = 1240;
	  unsigned int packet_height = 650;

	Yes, this should be a command line option, but its a proof-of-concept ..

